<p align="center">
  <a href="https://foalts.org" target="blank">
    <img src="https://raw.githubusercontent.com/FoalTS/foal/master/docs/static/img/logo.png" alt="Logo" />
  </a>
  <br>
</p>

<p align="center">
  <a href="https://github.com/FoalTS/foal/blob/master/LICENSE">
    <img src="https://img.shields.io/badge/License-MIT-blue.svg" alt="License: MIT">
  </a>
  <img src="https://img.shields.io/badge/node-%3E%3D10-brightgreen.svg" alt="node version">
  <a href="https://badge.fury.io/js/%40foal%2Fjwt">
    <img src="https://badge.fury.io/js/%40foal%2Fjwt.svg" alt="npm version">
  </a>
  <a href="https://github.com/FoalTS/foal/actions">
    <img src="https://github.com/FoalTS/foal/workflows/Test/badge.svg" alt="Build Status">
  </a>
  <a href="https://snyk.io/test/npm/@foal/typeorm">
    <img src="https://snyk.io/test/npm/@foal/typeorm/badge.svg" alt="Known Vulnerabilities">
  </a>
  <a href="https://github.com/FoalTS/foal/commits/master">
    <img src="https://img.shields.io/github/commit-activity/y/FoalTS/foal.svg" alt="Commit activity">
  </a>
  <a href="https://github.com/FoalTS/foal/commits/master">
    <img src="https://img.shields.io/github/last-commit/FoalTS/foal.svg" alt="Last commit">
  </a>
  <a href="https://img.shields.io/badge/2FA-npm,%20GitHub-green.svg">
    <img src="https://img.shields.io/badge/2FA-npm,%20GitHub-green.svg" alt="2FA">
  </a>
  <a href="https://discord.gg/QUrJv98">
    <img src="https://img.shields.io/badge/Chat-Discord-blue.svg" alt="2FA">
  </a>
</p>

## What is Foal?

*Foal* (or *FoalTS*) is a Node.JS framework for creating web applications.

It provides a set of ready-to-use components so you don't have to reinvent the wheel every time. In one single place, you have a complete environment to build web applications. This includes a CLI, testing tools, frontend utilities, scripts, advanced authentication, ORM, deployment environments, GraphQL and Swagger API, AWS utilities, and more. You no longer need to get lost on npm searching for packages and making them work together. All is provided.

But while offering all these features, the framework remains simple. Complexity and unnecessary abstractions are put aside to provide the most intuitive and expressive syntax. We believe that concise and elegant code is the best way to develop an application and maintain it in the future. It also allows you to spend more time coding rather than trying to understand how the framework works.

Finally, the framework is entirely written in TypeScript. The language brings you optional static type-checking along with the latest ECMAScript features. This allows you to detect most silly errors during compilation and improve the quality of your code. It also offers you autocompletion and a well documented API.

<p align="center">
  <a href="https://foalts.org">https://foalts.org</a>
</p>
